app.addMenuItem({ 
  cName: 'Extract matching the list',
  cParent: 'Tools', 
  cExec: 'ExtractMatchingTheList()'
});


app.addMenuItem({ 
  cName: 'Extract matching the list+',
  cParent: 'Tools', 
  cExec: 'ExtractMatchingTheListAdd()'
});


ExtractMatchingTheList = app.trustedFunction(
 function(ExtractMatchingTheList) {
    app.beginPriv();
//-----------------------------------------------

var textArray = [], pagesArr = [];
var fPath = this.path;
var re = /\.pdf$/i;
var filename = this.documentFileName.replace(re,"");
var datafilename = (filename+".txt");
var outfilename = (filename+"_matching_the_list+.pdf");
var rStream = util.readFileIntoStream(datafilename);
var findTextArr = util.stringFromStream(rStream).split("\r\n");

for (var i = 0; i < this.numPages; i++) { 
    numWords = this.getPageNumWords(i);
    var pageString = "";
    for (var j = 0; j < numWords; j++) 
    {
        pageString = pageString + this.getPageNthWord(i, j, false);
    }
	textArray.push(pageString.replace("\r", "").replace("\n", ""));
};

for (var n = 0; n < findTextArr.length; n++) {
	for (var j = 0; j < textArray.length; j++)
		if (textArray[j] === findTextArr[n]) {
			pagesArr.push(j)
			//pagesArr.push(j+1)
		};
};

pagesArr = uniq_fast(pagesArr);
if (pagesArr.length > 0) {
	var d = app.newDoc(); 
	for (var n = 0; n < pagesArr.length; n++) {
		d.insertPages( {
			nPage: d.numPages-1,
			cPath: fPath,
			nStart: pagesArr[n],
			nEnd: pagesArr[n],
		} );
	};
    d.deletePages(0);
	d.saveAs (outfilename);
};

//-----------------------------------------------
    app.endPriv();
}); 

ExtractMatchingTheListAdd = app.trustedFunction(
 function(ExtractMatchingTheListAdd) {
    app.beginPriv();
//-----------------------------------------------

var textArray = [], pagesArr = [];
var fPath = this.path;
var re = /\.pdf$/i;
var filename = this.documentFileName.replace(re,"");
var datafilename = (filename+".txt");
var outfilename = (filename+"_matching_the_list.pdf");
var rStream = util.readFileIntoStream(datafilename);
var findTextArr = util.stringFromStream(rStream).split("\r\n");

for (var i = 0; i < this.numPages; i++) { 
    numWords = this.getPageNumWords(i);
    var pageString = "";
    for (var j = 0; j < numWords; j++) 
    {
        pageString = pageString + this.getPageNthWord(i, j, false);
    }
	textArray.push(pageString.replace("\r", "").replace("\n", ""));
};

for (var n = 0; n < findTextArr.length; n++) {
	for (var j = 0; j < textArray.length; j++)
		if (textArray[j] === findTextArr[n]) {
			pagesArr.push(j)
			pagesArr.push(j+1)
		};
};

pagesArr = uniq_fast(pagesArr);
if (pagesArr.length > 0) {
	var d = app.newDoc(); 
	for (var n = 0; n < pagesArr.length; n++) {
		d.insertPages( {
			nPage: d.numPages-1,
			cPath: fPath,
			nStart: pagesArr[n],
			nEnd: pagesArr[n],
		} );
	};
    d.deletePages(0);
	d.saveAs (outfilename);
};

//-----------------------------------------------
    app.endPriv();
}); 


function uniq_fast(a) {
    var seen = {};
    var out = [];
    var len = a.length;
    var j = 0;
    for(var i = 0; i < len; i++) {
         var item = a[i];
         if(seen[item] !== 1) {
               seen[item] = 1;
               out[j++] = item;
         }
    }
    return out;
}